#ifndef _STDIO_H
#include <stdio.h>
#endif
#define BEVERBOSE
#define LOGPATH "/dev/log"
#define LOGFILE "/var/logit/logfile"
#define MAXIDENT 15
#define MAXLOG 1000
#define MAXCFFILE 200
#define CONFIG "/var/logit/config"
#define LFCOUNT 12
#define LOGITPORT 7777
#define RLEN (16+1)
#define SRVLOG "/var/logit/logserv"
#define KLOG "/proc/kmsg"

#define MYCLILOG "/var/logit/logit_err"
#define MYSRVLOG "/var/logit/logserv_err"

#define AUTH_DEF     LOGFILE
#define AUTHPRIV_DEF LOGFILE
#define CRON_DEF     LOGFILE
#define DAEMON_DEF   LOGFILE
#define KERN_DEF     LOGFILE
#define LPR_DEF      LOGFILE
#define MAIL_DEF     LOGFILE
#define NEWS_DEF     LOGFILE
#define SYSLOG_DEF   LOGFILE
#define USER_DEF     LOGFILE
#define UUCP_DEF     LOGFILE
#define FTP_DEF      LOGFILE

#define LOG_KERN     (0<<3)
#define LOG_USER     (1<<3)
#define LOG_MAIL     (2<<3)
#define LOG_DAEMON   (3<<3)
#define LOG_AUTH     (4<<3)
#define LOG_SYSLOG   (5<<3)
#define LOG_LPR      (6<<3)
#define LOG_NEWS     (7<<3)
#define LOG_UUCP     (8<<3)
#define LOG_CRON     (9<<3)
#define LOG_AUTHPRIV (10<<3)
#define LOG_FTP	     (11<<3)

/* our protos */
void reaper(int);

/* syslog.c */
FILE *openLOG(const char*);
int closeLOG(FILE*);
int printLOG(FILE*, char*);
int printDate(FILE*);
int createSocket(const char*);

/* main.c */
int parseConfigfile(const char*);
int startx(void);
int openLogfiles(FILE* fd[]);

/* net.c */
int makeconnection(const char*, int);
int getconnection(int);

/* proto.c */
int getRandomstring(char*, int);
int srvProto(FILE*);
int cliProto(int);
int calcResponse(char *, char*);

/* some wrapperfunctions */
FILE *Fopen(const char*, const char*);
FILE *Fdopen(int, const char*);
void *Malloc(int);

int my_encrypt(char*, char*, char*);
int my_decrypt(char*, char*, char*);


/* our internal struct for the configfile */
struct conf {
	char *handle;
	char *file;
	int changed;
};

/* the pipes */
struct pstruct {
   	int fd[2];
        char url[256];
};

extern const char* errstring;
extern struct conf LF[];
extern struct pstruct pipes[];
extern int forkcount;

extern FILE *clilog;
extern FILE *srvlog;

#ifdef STDC_HEADERS
int fileno(FILE*);
FILE *fdopen(int, const char*);
int setreuid(int,int);
#endif

#define LOGIT_MSG "logit V 1.0 started, forking into background. (C) 1999/2000 by S. Krahmer\n"
#define LOGSERV_MSG "logserv V 1.0 started, forking into background. (C) 1999/2000 by S. Krahmer\n"
