/*** This file is part of the logit program. (C) 1999/2000 by S. Krahmer
 *** This program can be used under the terms of the GPL.
 *** There is absolutely NO WARRANTY for this program.
 *** You use this at your own risk! 
 *** 
 *** The logit package contains code for strong crypto (RC4).
 *** Be sure that you don't get any conflicts with the law of your
 *** country. I'm not responsible for any damage or trouble you'll
 *** maybe get due to using this program.
 ***
 *** S. Krahmer 	<krahmer@cs.uni-potsdam.de>
 ***/
#include "portable.h"
#include "logit.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <string.h>
#include <errno.h>
#include <signal.h>

int handleChild(int, struct sockaddr_in*);

int
main(void)
{
   	int fd = 0, afd = 0, pid = 0;
        struct sockaddr_in saddr;
        unsigned int size = 0;

	setreuid(77, 77);
         
	size = sizeof(saddr);
        memset(&saddr, 0, size);
        
        umask(037);        
        if ((srvlog = fopen(MYSRVLOG, "a+")) == NULL) {
           	perror("fopen");
                exit(errno);
        }        
        printf(LOGSERV_MSG);

        printDate(srvlog);
        fprintf(srvlog, "[logserv] started.\n");
	fflush(srvlog);
	        
#ifndef DEBUG        
        if ((pid = fork()) < 0) {
           	perror("fork");
           	exit(errno);
        } else if (pid > 0)
           	exit(0);
#endif
        
        fd = getconnection(LOGITPORT);
   	while (1) {
		errno = 0;
                afd = accept(fd, (struct sockaddr*)&saddr, &size);
		if (errno == EINTR)
			continue;
		else if (errno != 0) {
			perror("accept");
			exit(errno);
		}	
                signal(SIGCHLD, reaper);
                handleChild(afd, &saddr);
        }
        
}

/* handle one connection, received by accept() */
int
handleChild(int afd, struct sockaddr_in *saddr)
{
   	FILE *fd, *log;
        int pid = 0, t = 0, dont_close = 0;        

#ifndef DEBUG  
        if ((pid = fork()) < 0) {
           	printDate(srvlog);
                fprintf(srvlog, "Ups...cannot fork! (errno = %d)\n", errno);
        /* as parent, go back and wait again */
        } else if (pid > 0) {
           	close(afd);
           	return 0;
        }
#endif
        /* open a logfile */
        if ((log = fopen(SRVLOG, "a+")) == NULL) {
           	printDate(srvlog);
                fprintf(srvlog, "[logserv] Can't open %s (errno = %d):\n", SRVLOG, errno);
                /* same as in proto.c, line 56 */
                dup2(fileno(srvlog), t);
                if ((log = fdopen(t, "a+")) == NULL) {
                   	dont_close++;
                        log = srvlog;
                }
        }
        if ((fd = fdopen(afd, "a+")) == NULL) {
           	printDate(srvlog);
                fprintf(srvlog, "[logserv] Can't establish connection (errno = %d)\n", errno);
                return -1;
        }                      
        fprintf(log, "%s ", inet_ntoa(saddr->sin_addr));
        if (!dont_close)
           	fclose(log);
        
        /* really handle connection */
        srvProto(fd);
        fclose(fd);
#ifndef DEBUG
        exit(0);
#else
        return 0;
#endif
}

