/*** Simple network functions for logit.
 *** It's under the GPL.
 *** Use this at your own risk. I'm not responsible for any damage
 *** this package may cause.
 ***
 *** S. Krahmer 	<krahmer@cs.uni-potsdam.de>
 ***/
#include "portable.h"
#include "logit.h"
#include <stdio.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <string.h>
#include <arpa/inet.h>
#include <errno.h>

/* fire up a connection */
int makeconnection(const char* host, int port)
{
   	struct sockaddr_in saddr;
        struct hostent *hos;
        int sfd = 0;
        
        
        if ((hos = gethostbyname(host)) == NULL) {
           	printf("gethostbyname %s", host);
                return errno;
        }
        memset(&saddr, 0, sizeof(saddr));
        saddr.sin_port = htons(port);
        saddr.sin_family = AF_INET;
        memcpy(&(saddr.sin_addr), hos->h_addr, hos->h_length);
#ifdef DEBUG        
        printf("%s\n", inet_ntoa(saddr.sin_addr));
#endif
        if ((sfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
           	perror("socket");
                return errno;
        }
        if (connect(sfd, (struct sockaddr*)&saddr, sizeof(saddr)) < 0) {
           	perror("connect");
                return errno;
        }
        return sfd;
}

/* return a descriptor wich we can use for accept() */
int getconnection(int port)
{
   	struct sockaddr_in saddr;
        
        int sfd = 0;
        
        if ((sfd =  socket(AF_INET, SOCK_STREAM, 0)) < 0) {
           	perror("socket");
                return errno;
        }
        saddr.sin_port = htons(port);
        saddr.sin_family = AF_INET;
        saddr.sin_addr.s_addr = INADDR_ANY;
        if (bind(sfd, (struct sockaddr*)&saddr, sizeof(saddr)) < 0) {
           	perror("bind");
                return errno;
        }
        listen(sfd, 10);
        return sfd;
}
      
