/*** This file is part of the logit program. It's under the GPL.
 *** You use this at your own risk. I'm not responsible for any damage
 *** or trouble you maybe get due to using this program.
 ***
 *** S. Krahmer 	<krahmer@cs.uni-potsdam.de>
 ***/
#include "portable.h"
#include "logit.h"
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/un.h>
  
/* create UNIX-domain socket for logging messages */
int 
createSocket(const char *path)
{
        int fd = 0;
        struct sockaddr_un un_addr;

        
        /* if there already exists a file, delete */
        unlink(path);
		
        if ((fd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0) {
		perror("socket");
		exit(errno);
	}
	un_addr.sun_family = AF_UNIX;
	strncpy(un_addr.sun_path, path, 10);
	if (bind(fd, (struct sockaddr*)&un_addr, sizeof(un_addr)) < 0) {
		perror("bind");
		exit(errno);
	}
	if (listen(fd, 10) < 0) {
		perror("listen");
		exit(errno);
	}
	chown(path, 77, 77);
	chmod(path, 0770);
	return fd;
}


FILE* openLOG(const char *path)
{
        FILE* fd = NULL;

        if ((fd = fopen(path, "a+")) == NULL) 
           	return NULL;
        return fd;
}

int 
closeLOG(FILE *fd)
{
        if (fclose(fd) < 0) {
                perror("closeXXX > fclose");
                exit(errno);
        }
        return 0;
}


int 
printDate(FILE *fd)
{
        time_t tp;
        struct tm *dat;
        char *months[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
                          "Aug", "Sep", "Oct", "Nov", "Dec"};
                          
        char *wday[] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};

        tp = time(NULL);
        dat = localtime(&tp);
        
        /* Be aware! Everyone will kill us...*/
        if (dat->tm_mon > 11) {
               fprintf(stderr, "%s", errstring);
               dat->tm_mon = 0;
        }
        if (dat->tm_wday > 6) {
               fprintf(stderr, "%s", errstring);
               dat->tm_wday = 0;
        }
#ifdef BEVERBOSE
        fprintf(fd, "%s %02d %s %02d %02d:%02d:%02d ",
                    wday[dat->tm_wday], dat->tm_mday,
                    months[dat->tm_mon], dat->tm_year,
                    dat->tm_hour, dat->tm_min, dat->tm_sec);
#else
        fprintf(fd, "%02d %s %02d:%02d:%02d ",
                    dat->tm_mday, months[dat->tm_mon], dat->tm_hour,
                    dat->tm_min, dat->tm_sec);
#endif

        fflush(fd);
        return 0;
}

int 
printLOG(FILE *fd, char *logbuf)
{
   	
        if (logbuf[strlen(logbuf) - 1] == '\n') 
           	logbuf[strlen(logbuf) - 1] = '\0';
        fprintf(fd, "%s\n", logbuf);
        fflush(fd);
        return 0;
}

